Attribute VB_Name = "AOLToolz"
Option Explicit

Public Const WM_GETTEXTLENGTH As Long = &HE
Public Const WM_GETTEXT As Long = &HD
Const WM_SETTEXT As Long = &HC
Const WM_LBUTTONDOWN = &H201
Const WM_LBUTTONUP = &H202
Const WM_LBUTTONDBLCLK = &H203
Const MK_LBUTTON = &H1
Const WM_KEYUP = &H101
Const WM_KEYDOWN = &H100
Const LB_GETTEXT = &H189
Const LB_GETTEXTLEN = &H18A
Const LB_GETCOUNT = &H18B
Const LB_GETITEMDATA = &H199
Const MaxNameLen = 16 + 1
Const PROCESS_VM_READ = &H10
Public Const HWND_TOPMOST = -1
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOSIZE = &H1
Public Const SM_CXVSCROLL = 2
Private Const WS_CHILD = &H40000000
Private Const GWL_HWNDPARENT = (-8)
Private Const GWL_STYLE = (-16)
Private Const HWND_TOP = 0&
Private Const SWP_NOZORDER = &H4
Private Const SWP_NOACTIVATE = &H10
Private Const SWP_SHOWWINDOW = &H40

Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Global AOLhWnd As Long 'Aol
Global ChatRoomName As String
Global ChathWnd As Long 'Chat room text
Global TexthWnd As Long 'Text to send box
Global SendhWnd As Long 'Send button
Global AOLhProcess As Long
Global AOLOpenhProcess As Long
Global PeoplehWnd As Long 'List box of people
Global PeopleCount As Byte
Global PeopleList(1 To 23) As String
'Global PersonName(1 To MaxNameLen) As Byte

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
    (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function SendMessageByString Lib "user32" Alias "SendMessageA" _
    (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
Private Declare Function EnumWindows Lib "user32" _
    (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Private Declare Function EnumChildWindows Lib "user32" _
    (ByVal hWndParent As Long, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" _
    (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function GetClassName Lib "user32" Alias "GetClassNameA" _
    (ByVal hWnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Public Declare Function IsWindow Lib "user32" _
    (ByVal hWnd As Long) As Long
Public Declare Function IsBadStringPtr Lib "kernel32" Alias "IsBadStringPtrA" (ByVal lpsz As String, ByVal ucchMax As Long) As Long
Public Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hWnd As Long, lpdwProcessId As Any) As Long
Public Declare Function ReadProcessMemory Lib "kernel32" (ByVal hProcess As Long, ByVal lpBaseAddress As Long, ByVal lpBuffer As String, ByVal nSize As Long, lpNumberOfBytesWritten As Long) As Long
Public Declare Function lstrcpy Lib "kernel32" Alias "lstrcpyA" (ByVal lpString1 As String, ByVal lpString2 As Any) As Long
Public Declare Function GetLastError Lib "kernel32" () As Long
Public Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Public Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Public Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Public Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long

Public Function GetLastLine(ByVal hWnd As Long) As String
    Dim TempText As String, TextLen As Long
    TextLen = SendMessage(hWnd, WM_GETTEXTLENGTH, 0, 0) + 1
    TempText = String$(TextLen + 1, 0)
    Call SendMessageByString(hWnd, WM_GETTEXT, TextLen, TempText)
    GetLastLine = Mid(TempText, InStrRev(TempText, vbCr) + 1)
End Function

Public Function ScramblePhrase(ByVal Phrase As String) As String
    Dim Arr() As String
    Dim Count1 As Byte
    Arr = Split(Phrase, " ")
    Do
        For Count1 = 0 To UBound(Arr)
            Arr(Count1) = ScrambleWord(Arr(Count1))
        Next Count1
        ScramblePhrase = Join(Arr(), " ")
    Loop While ScramblePhrase = Phrase
End Function

Private Function ScrambleWord(ByVal Word As String) As String
    Dim Count1 As Byte
    Dim TempRnd As Byte
    Dim Temp As String
    Dim UsedChars() As Boolean
    Temp = Space$(Len(Word))
    ReDim UsedChars(1 To Len(Word)) As Boolean
    For Count1 = 1 To Len(Word)
        Do
            TempRnd = Int(Rnd * Len(Word) + 1)
        Loop While UsedChars(TempRnd)
        UsedChars(TempRnd) = True
        Mid(Temp, TempRnd, 1) = Mid(Word, Count1, 1)
    Next Count1
    ScrambleWord = Temp
End Function

Public Sub SendChatMessage(ByVal Message As String, Optional DoPause As Boolean = True)
    Call SendMessageByString(TexthWnd, WM_SETTEXT, 0, Message)
    Call SendMessage(SendhWnd, WM_LBUTTONDOWN, MK_LBUTTON, 0)
    Call SendMessage(SendhWnd, WM_KEYDOWN, vbKeySpace, 0)
    Call SendMessage(SendhWnd, WM_KEYUP, vbKeySpace, 0)
    Call SendMessage(SendhWnd, WM_LBUTTONUP, MK_LBUTTON, 0)
    If DoPause Then
        Pause (1.5)
    End If
End Sub

Public Function GetHandles() As Boolean
    Dim TemphProcess As Double
    Call EnumWindows(AddressOf GetAOLHandle, 0)
    AOLhProcess = 1
    Call GetWindowThreadProcessId(AOLhWnd, AOLhProcess)
    If AOLhWnd <> 0 Then
        Call EnumChildWindows(AOLhWnd, AddressOf GetChatHandles, 0)
        If ChatRoomName = "" Then
            Exit Function
        End If
    Else
        Exit Function
    End If
    GetHandles = True
End Function

Private Function GetChatHandles(ByVal hWnd As Long, ByVal lpData As Long) As Long
    Const MaxWinLen As Long = 64
    Static hWndCount As Integer
    Dim WindClass As String
    Dim WindName As String
    Dim Ret As Long
    WindName = String$(MaxWinLen, 0)
    Ret = GetWindowText(hWnd, WindName, MaxWinLen - 1)
    WindName = Left$(WindName, Ret)
    WindClass = String$(MaxWinLen, 0)
    Ret = GetClassName(hWnd, WindClass, MaxWinLen - 1)
    WindClass = Left$(WindClass, Ret)
    If WindClass = "AOL Child" Then
        ChathWnd = 0
        TexthWnd = 0
        SendhWnd = 0
        hWndCount = -1
        ChatRoomName = WindName
    End If
    hWndCount = hWndCount + 1
    If WindClass = "RICHCNTLREADONLY" And hWndCount = 2 Then
        ChathWnd = hWnd
    End If
    If WindClass = "RICHCNTL" And hWndCount = 10 Then
        TexthWnd = hWnd
    End If
    If WindClass = "_AOL_Icon" And hWndCount = 11 Then
        SendhWnd = hWnd
    End If
    If WindClass = "_AOL_Static" And hWndCount = 14 Then
        PeopleCount = Val(WindName)
    End If
    If WindClass = "_AOL_Listbox" And hWndCount = 16 Then
        PeoplehWnd = hWnd
    End If
    If WindName = "AOL_CHAT_FORM" And WindClass = "_AOL_Static" And hWndCount = 25 Then
        GetChatHandles = 0
        Exit Function
    ElseIf hWndCount > 29 Then
        ChatRoomName = ""
    End If
    GetChatHandles = 1
End Function

Private Function GetAOLHandle(ByVal hWnd As Long, ByVal lpData As Long) As Long
    Const MaxWinLen As Long = 64
    Dim WindName As String
    Dim WindClass As String
    Dim Ret As Long
    WindName = String$(MaxWinLen, 0)
    Ret = GetWindowText(hWnd, WindName, MaxWinLen - 1)
    WindName = Left$(WindName, Ret)
    WindClass = String$(MaxWinLen, 0)
    Ret = GetClassName(hWnd, WindClass, MaxWinLen - 1)
    WindClass = Left$(WindClass, Ret)
    AOLhWnd = 0
    If Left(WindName, 15) = "America  Online" Then
        If WindClass = "AOL Frame25" Then
            AOLhWnd = hWnd
            GetAOLHandle = 0
            Exit Function
        End If
    End If
    GetAOLHandle = 1
End Function

Public Sub GetPeopleList()
    Dim Count1 As Byte
    Dim Ret As Long
    Dim NameLen As Long
    Dim NamehWnd As Long
    Dim TempNamehWnd As String
    Dim Name_ As String
    PeopleCount = SendMessage(PeoplehWnd, LB_GETCOUNT, 0, 0)
    For Count1 = 0 To PeopleCount - 1
        TempNamehWnd = SendMessage(PeoplehWnd, LB_GETITEMDATA, Count1, 0)
        'TempNamehWnd = String(4, 0)
        'Ret = SendMessageByString(PeoplehWnd, LB_GETTEXT, Count1, TempNamehWnd)
        Ret = 1
        'NamehWnd = Convert4ByteStrToLong(TempNamehWnd)
        'Ret = IsBadStringPtr(Val(TempNamehWnd), MaxNameLen)
        NamehWnd = Val(TempNamehWnd)
        Name_ = String(MaxNameLen, 0)
        AOLOpenhProcess = OpenProcess(PROCESS_VM_READ, 0, AOLhProcess)
        Ret = ReadProcessMemory(AOLOpenhProcess, NamehWnd, Name_, MaxNameLen, NameLen)
        Name_ = StrConv(Name_, vbWide)
        Ret = CloseHandle(AOLOpenhProcess)
    Next Count1
End Sub

Private Function Convert4ByteStrToLong(Value As String) As Long
    Convert4ByteStrToLong = Asc(Mid(Value, 1, 1)) + 2 * Asc(Mid(Value, 2, 1)) + 4 * Asc(Mid(Value, 3, 1)) + 8 * Asc(Mid(Value, 4, 1))
End Function

Private Function GetScreenName(ByVal hWnd As Long, ByVal lpData As Long) As Long
    Const MaxWinLen As Long = 64
    Dim WindClass As String
    Dim WindName As String
    Dim Ret As Long
    WindName = String$(MaxWinLen, 0)
    Ret = GetWindowText(hWnd, WindName, MaxWinLen - 1)
    WindName = Left$(WindName, Ret)
    WindClass = String$(MaxWinLen, 0)
    Ret = GetClassName(hWnd, WindClass, MaxWinLen - 1)
    WindClass = Left$(WindClass, Ret)
    If WindClass = "AOL Child" Then
        If InStr(1, WindName, "Welcome, ") <> 0 And InStr(1, WindName, "!") <> 0 Then
            If InStr(1, Mid$(WindName, 9), RegisteredName) = 0 Then
                MsgBox "WARNING! You are not the registered user!" & vbCrLf & _
                    "E-Mail: MaxxZephyr@aol.com to get your registered version!" & vbCrLf & _
                    "Shutting Down!", vbCritical Or vbOKOnly, "Unregistered Version"
                End
            End If
        End If
    End If
    GetScreenName = 1
End Function

Public Static Sub Pause(Seconds As Single)
    Dim Time As Single
    Time = Timer
    Do
    Loop Until Timer - Time > Seconds
End Sub

Public Sub SetWindowAsChild(ChildhWnd As Long, ParenthWnd As Long)
    Dim BoxRect As RECT
    Dim CurrentStyle As Long
    Call GetClientRect(ParenthWnd, BoxRect)
    CurrentStyle = GetWindowLong(ChildhWnd, GWL_STYLE) Or WS_CHILD
    Call SetWindowLong(ChildhWnd, GWL_STYLE, CurrentStyle)
    Call SetParent(ChildhWnd, ParenthWnd)
    Call SetWindowLong(ChildhWnd, GWL_HWNDPARENT, ParenthWnd)
    Call SetWindowPos(ChildhWnd, HWND_TOPMOST, 0&, 0&, BoxRect.Right, BoxRect.Bottom, SWP_NOZORDER Or SWP_SHOWWINDOW Or SWP_NOMOVE Or SWP_NOSIZE)
End Sub
