Attribute VB_Name = "BaseConversions"
Option Explicit

Private Function ConvertDecimalTo(ByVal Number As Variant, ToBase As Byte) As Variant
    Dim TempVal1 As Variant
    Dim Remainder As Variant
    If IsNumeric(Number) Then
        Number = Int(Number)
    End If
    Do While Number <> 0
        TempVal1 = Int(Number / ToBase)
        Remainder = Number - (TempVal1 * ToBase)
        ConvertDecimalTo = ConvertDecimalTo & IIf(Remainder < 10, Remainder, Chr(Asc("A") + (Remainder - 10)))
        Number = TempVal1
    Loop
    ConvertDecimalTo = StrReverse$(ConvertDecimalTo)
End Function

Private Function ConvertToDecimal(ByVal Number As Variant, FromBase As Byte) As Variant
    If IsNumeric(Number) Then
        Number = Int(Number)
    End If
    Do While Len(Number) > 1
        ConvertToDecimal = (ConvertToDecimal + IIf(IsNumeric(Left$(Number, 1)), Left$(Number, 1), 10 + Asc(Left$(Number, 1)) - Asc("A"))) * FromBase
        Number = Right$(Number, Len(Number) - 1)
    Loop
    ConvertToDecimal = ConvertToDecimal + IIf(IsNumeric(Number), Number, 10 + Asc(Number) - Asc("A"))
End Function

Public Function Convert(ByVal Number As Variant, Optional FromBase As Byte = 10, Optional ToBase As Byte = 2) As Variant
    If FromBase = 10 Then
        Convert = ConvertDecimalTo(Number, ToBase)
    ElseIf ToBase = 10 Then
        Convert = ConvertToDecimal(Number, FromBase)
    Else
        Convert = ConvertDecimalTo(ConvertToDecimal(Number, FromBase), ToBase)
    End If
End Function
