VERSION 5.00
Begin VB.Form frmCategory 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Category Loader"
   ClientHeight    =   3135
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7935
   Icon            =   "frmGallery.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3135
   ScaleWidth      =   7935
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK!"
      BeginProperty Font 
         Name            =   "Small Fonts"
         Size            =   6
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   4920
      TabIndex        =   8
      Top             =   2520
      Width           =   495
   End
   Begin VB.CommandButton cmdRemoveSelected 
      Caption         =   ""
      BeginProperty Font 
         Name            =   "Symbol"
         Size            =   8.25
         Charset         =   2
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   4920
      TabIndex        =   7
      Top             =   1920
      Width           =   495
   End
   Begin VB.CommandButton cmdRemoveAll 
      Caption         =   ""
      BeginProperty Font 
         Name            =   "Symbol"
         Size            =   8.25
         Charset         =   2
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   4920
      TabIndex        =   6
      Top             =   1320
      Width           =   495
   End
   Begin VB.CommandButton cmdAddSelected 
      Caption         =   ""
      BeginProperty Font 
         Name            =   "Symbol"
         Size            =   8.25
         Charset         =   2
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   4920
      TabIndex        =   5
      Top             =   720
      Width           =   495
   End
   Begin VB.CommandButton cmdAddAll 
      Caption         =   ""
      BeginProperty Font 
         Name            =   "Symbol"
         Size            =   8.25
         Charset         =   2
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   4920
      TabIndex        =   4
      Top             =   120
      Width           =   495
   End
   Begin VB.ListBox lstSelectedFiles 
      Height          =   2670
      IntegralHeight  =   0   'False
      ItemData        =   "frmGallery.frx":030A
      Left            =   5520
      List            =   "frmGallery.frx":030C
      MultiSelect     =   2  'Extended
      TabIndex        =   3
      Top             =   120
      Width           =   2295
   End
   Begin VB.FileListBox fileFiles 
      Height          =   2625
      Left            =   2520
      MultiSelect     =   2  'Extended
      TabIndex        =   2
      Top             =   165
      Width           =   2295
   End
   Begin VB.DirListBox dirDirectory 
      Height          =   2340
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   2295
   End
   Begin VB.DriveListBox cboDrive 
      Height          =   315
      Left            =   120
      TabIndex        =   0
      Top             =   150
      Width           =   2295
   End
   Begin VB.Label lblSelectedItem 
      AutoSize        =   -1  'True
      Caption         =   "Selected Item: None"
      Height          =   195
      Left            =   120
      TabIndex        =   9
      Top             =   2880
      Width           =   1455
   End
End
Attribute VB_Name = "frmCategory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cboDrive_Change()
    On Error Resume Next
    dirDirectory.Path = UCase$(Left$(cboDrive.Drive, 1) & ":\")
End Sub

Private Sub cmdAddAll_Click()
    Dim Count1 As Integer
    For Count1 = 0 To fileFiles.ListCount - 1
        lstSelectedFiles.AddItem dirDirectory.Path & "\" & fileFiles.List(Count1)
    Next Count1
    lstSelectedFiles.SetFocus
End Sub

Private Sub cmdAddSelected_Click()
    Dim Count1 As Integer
    For Count1 = 0 To fileFiles.ListCount - 1
        If fileFiles.Selected(Count1) Then
            lstSelectedFiles.AddItem dirDirectory.Path & "\" & fileFiles.List(Count1)
        End If
    Next Count1
    fileFiles.SetFocus
End Sub

Private Sub cmdOK_Click()
    If lstSelectedFiles.ListCount < 1 Then
        GoTo cancel
    End If
    Dim Count1 As Integer
    ReDim Categories(1 To lstSelectedFiles.ListCount)
    For Count1 = 0 To lstSelectedFiles.ListCount - 1
        Categories(Count1 + 1) = lstSelectedFiles.List(Count1)
    Next Count1
    CategoryCount = UBound(Categories)
cancel:
    Unload Me
End Sub

Private Sub cmdRemoveAll_Click()
    lstSelectedFiles.Clear
    lblSelectedItem.Caption = "Selected Item: None"
    fileFiles.SetFocus
End Sub

Private Sub cmdRemoveSelected_Click()
    Dim Count1 As Integer
    For Count1 = lstSelectedFiles.ListCount - 1 To 0 Step -1
        If lstSelectedFiles.Selected(Count1) Then
            lstSelectedFiles.RemoveItem Count1
        End If
    Next Count1
    lstSelectedFiles.SetFocus
End Sub

Private Sub dirDirectory_Change()
    On Error Resume Next
    fileFiles.Path = dirDirectory.Path
End Sub

Private Sub Form_Load()
    Call SetWindowPos(Me.hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE) 'Set topmost
End Sub

Private Sub lstSelectedFiles_Click()
    Dim Count1 As Integer
    For Count1 = 0 To lstSelectedFiles.ListCount - 1
        If lstSelectedFiles.Selected(Count1) Then
            lblSelectedItem.Caption = "Selected Item: " & lstSelectedFiles.List(Count1)
            Exit Sub
        End If
    Next Count1
    lblSelectedItem.Caption = "Selected Item: None"
End Sub
