VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "AOL 7.0 Scrambler Bot by Maxx Zephyr"
   ClientHeight    =   2415
   ClientLeft      =   150
   ClientTop       =   720
   ClientWidth     =   6855
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   2415
   ScaleWidth      =   6855
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdSendMessage 
      Caption         =   "Send"
      Height          =   375
      Left            =   6120
      TabIndex        =   6
      Top             =   1920
      Width           =   615
   End
   Begin VB.TextBox txtChatMessage 
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   120
      MaxLength       =   232
      TabIndex        =   5
      Top             =   1920
      Width           =   5895
   End
   Begin VB.ListBox lstContestants 
      Height          =   1575
      IntegralHeight  =   0   'False
      Left            =   3480
      Sorted          =   -1  'True
      Style           =   1  'Checkbox
      TabIndex        =   4
      Top             =   240
      Width           =   3255
   End
   Begin VB.ComboBox cboCategory 
      Height          =   315
      ItemData        =   "frmMain.frx":030A
      Left            =   1440
      List            =   "frmMain.frx":0311
      Style           =   2  'Dropdown List
      TabIndex        =   3
      Top             =   240
      Width           =   1935
   End
   Begin VB.ListBox lstCategory 
      Height          =   1215
      IntegralHeight  =   0   'False
      ItemData        =   "frmMain.frx":0328
      Left            =   120
      List            =   "frmMain.frx":032A
      TabIndex        =   2
      Top             =   600
      Width           =   3255
   End
   Begin VB.Label lblIgnore 
      AutoSize        =   -1  'True
      Caption         =   "Check Screen Name To Ignore Person:"
      Height          =   195
      Left            =   3480
      TabIndex        =   7
      Top             =   0
      Width           =   2805
   End
   Begin VB.Label lblSelectCategory 
      AutoSize        =   -1  'True
      Caption         =   "Select Category:"
      Height          =   195
      Left            =   120
      TabIndex        =   1
      Top             =   300
      Width           =   1170
   End
   Begin VB.Label lblChatRoomName 
      AutoSize        =   -1  'True
      Caption         =   "Chat Room:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   0
      Width           =   840
   End
   Begin VB.Menu mnuScramblerMain 
      Caption         =   "&Scrambler"
      Begin VB.Menu mnuScramblerRefresh 
         Caption         =   "&Refresh"
         Shortcut        =   {F1}
      End
      Begin VB.Menu mnuSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuScramblerLoad 
         Caption         =   "&Load..."
         Shortcut        =   {F8}
      End
      Begin VB.Menu mnuSep2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuScramblerStart 
         Caption         =   "&Start"
         Enabled         =   0   'False
         Shortcut        =   {F2}
      End
      Begin VB.Menu mnuScramblerStop 
         Caption         =   "S&top"
         Enabled         =   0   'False
         Shortcut        =   {F3}
      End
      Begin VB.Menu mnuSep3 
         Caption         =   "-"
      End
      Begin VB.Menu mnuScramblerExit 
         Caption         =   "E&xit"
         Shortcut        =   {F9}
      End
   End
   Begin VB.Menu mnuVote 
      Caption         =   "&Vote!"
   End
   Begin VB.Menu mnuScoresMain 
      Caption         =   "S&cores"
      Enabled         =   0   'False
      Begin VB.Menu mnuScoresPrint 
         Caption         =   "&Print"
         Shortcut        =   {F4}
      End
      Begin VB.Menu mnuSep4 
         Caption         =   "-"
      End
      Begin VB.Menu mnuScoresReset 
         Caption         =   "&Reset"
         Shortcut        =   {F5}
      End
   End
   Begin VB.Menu mnuPhraseMain 
      Caption         =   "&Phrase"
      Enabled         =   0   'False
      Begin VB.Menu mnuPhraseHint 
         Caption         =   "&Hint"
         Shortcut        =   {F6}
      End
      Begin VB.Menu mnuSep5 
         Caption         =   "-"
      End
      Begin VB.Menu mnuPhraseReveal 
         Caption         =   "&Reveal"
         Shortcut        =   {F7}
      End
   End
   Begin VB.Menu mnuRules 
      Caption         =   "&Rules!"
      Enabled         =   0   'False
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const Blue As String = "<font color=#0000FF>"
Const Red As String = "<font color=#FF0000>"
Const Green As String = "<font color=#00AA00>"
Const Black As String = "<font color=#000000>"
Const Grey As String = "<font color=#888888>"
Const Header As String = Blue & " "
Const Footer As String = Blue & " "
Const CurrentSN As String = "KC Bachelor"
Const CurrentAOLVer As String = "8.0 BrOaDbAnD"

Private Enum EnableModeEnum
    NoRun = 0
    ReadyRun
    Running
End Enum

Dim ScramblerStop As Boolean
Dim Contestants As Variant
Dim Current As String
Dim PeopleToIgnore As Variant
Dim CurrentUnscrambled As Boolean

Private Sub cboCategory_Click()
    If cboCategory.ListIndex < 1 Then
        EnableControls NoRun
    Else
        LoadCategoryItems cboCategory.ListIndex
        Refresh_ (False)
    End If
End Sub

Private Sub LoadCategoryItems(Index As Integer)
    On Error GoTo cancel
    Dim FileNum As Byte
    Dim TempInfo As String
    FileNum = FreeFile
    Open Categories(Index) For Input As #FileNum
    lstCategory.Clear
    Do While Not EOF(FileNum)
        Line Input #FileNum, TempInfo
        TempInfo = Trim(TempInfo)
        If TempInfo <> "" And Len(TempInfo) > 1 Then 'Stupid to scramble spaces and 1 chars
            lstCategory.AddItem TempInfo
        End If
    Loop
    Close #FileNum
cancel:
End Sub

Private Sub Command1_Click()
    GetPeopleList
End Sub

Private Sub cmdSendMessage_Click()
    Dim Ret As Long
    Dim Temp As String * 100
    Ret = SendMessageByString(TexthWnd, WM_GETTEXT, 100, Temp)
    If Ret > 0 Then
        Pause 1.5
    End If
    SendChatMessage txtChatMessage.Text, False
    txtChatMessage.Text = ""
End Sub

Private Sub cmdSendMessage_GotFocus()
    txtChatMessage.SelStart = 0
    txtChatMessage.SelLength = Len(txtChatMessage.Text)
End Sub

Private Sub Form_Load()
    Call SetWindowPos(Me.hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE) 'Set topmost
    Randomize
    Set Contestants = CreateObject("Scripting.Dictionary")
    Set PeopleToIgnore = CreateObject("Scripting.Dictionary")
    cboCategory.ListIndex = 0
End Sub

Private Sub Form_QueryUnload(cancel As Integer, UnloadMode As Integer)
    End
End Sub

Private Sub lstContestants_ItemCheck(Item As Integer)
    Dim Count1 As Byte
    If lstContestants.Enabled Then
        If lstContestants.Selected(Item) Then
            SendChatMessage Header & Grey & "<b>" & Left(lstContestants.List(Item), InStr(1, lstContestants.List(Item), ":") - 1) & Black & "</b>  Temporarily " & Red & "<b><i>Ignored</b></i> " & Black & "by the game manager!" & Footer
        Else
            SendChatMessage Header & Grey & "<b>" & Left(lstContestants.List(Item), InStr(1, lstContestants.List(Item), ":") - 1) & Black & "</b>  Temporarily " & Green & "<b><i>Reinstated</b></i> " & Black & "by the game manager!" & Footer
        End If
    End If
    PeopleToIgnore.RemoveAll
    For Count1 = 0 To lstContestants.ListCount - 1
        If lstContestants.Selected(Count1) Then
            PeopleToIgnore.Add Left(lstContestants.List(Count1), InStr(1, lstContestants.List(Count1), ":") - 1), 0
        End If
    Next Count1
End Sub

Private Sub mnuPhraseHint_Click()
    SendChatMessage Header & Black & "Hint: " & Red & "<b>" & Left$(Current, Len(Current) - 1) & " " & Right(Current, 1) & "</b>" & Footer
End Sub

Private Sub mnuPhraseReveal_Click()
    SendChatMessage Header & Black & "Correct answer: " & Red & "<b>" & Current & "</b>" & Footer
    CurrentUnscrambled = True
End Sub

Private Sub mnuRules_Click()
    SendChatMessage Header & Black & "To play, <b>unscramble</b> the " & Red & "<b>phrase</b>" & _
        Black & " and <b>enter</b> your answer!" & Footer
    SendChatMessage Header & Green & "<b><i>Fastest response</i>" & "</b>" & Black & _
        " gets " & Green & "<b>points</b>" & Black & ", <b>most</b> points " & Red & "<b>" & _
        "<i>wins!</i></b>" & Footer
End Sub

Private Sub mnuScoresPrint_Click()
    PrintScores
End Sub

Private Sub mnuScoresReset_Click()
    lstContestants.Clear
    Contestants.RemoveAll
End Sub

Private Sub mnuScramblerExit_Click()
    Unload Me
End Sub

Private Sub mnuScramblerLoad_Click()
    frmCategory.Show vbModal
    LoadCategories
End Sub

Private Sub LoadCategories()
    Dim Count1 As Byte
    Dim Temp As String
    cboCategory.Clear
    cboCategory.AddItem "<Select Category>", 0
    For Count1 = 1 To CategoryCount
        Temp = Mid$(Categories(Count1), InStrRev(Categories(Count1), "\") + 1)
        cboCategory.AddItem Left$(Temp, InStr(1, Temp, ".") - 1), Count1
    Next Count1
    cboCategory.ListIndex = 0
End Sub

Private Sub mnuScramblerRefresh_Click()
    Refresh_ (True)
End Sub

Private Function Refresh_(RefreshNow As Boolean) As Boolean
    If RefreshNow Then
        If GetHandles Then
            lblChatRoomName.Caption = "Chat Room Name:  " & ChatRoomName
            Refresh_ = True
            EnableControls ReadyRun
        Else
            MsgBox "Either AOL is not open or there is no chat room open!", vbCritical, "Can't Run!"
            EnableControls NoRun
        End If
    Else
        If IsWindow(ChathWnd) And IsWindow(TexthWnd) And IsWindow(SendhWnd) Then
            Refresh_ = True
            EnableControls ReadyRun
        Else
            EnableControls NoRun
        End If
    End If
End Function

Private Sub mnuScramblerStart_Click()
    If Not Refresh_(False) Then Exit Sub
    ScramblerStop = False
    EnableControls Running
    Scramble
    EnableControls ReadyRun
End Sub

Private Sub EnableControls(EnableMode As EnableModeEnum)
    Select Case EnableMode
        Case NoRun
            mnuScramblerRefresh.Enabled = True
            mnuScramblerLoad.Enabled = True
            mnuScramblerExit.Enabled = True
            mnuScramblerStart.Enabled = False
            mnuScramblerStop.Enabled = False
            mnuScoresMain.Enabled = True
            mnuScoresReset.Enabled = True
            mnuScoresPrint.Enabled = False
            mnuPhraseMain.Enabled = False
            mnuRules.Enabled = False
            cboCategory.Enabled = True
        Case ReadyRun
            mnuScramblerRefresh.Enabled = True
            mnuScramblerLoad.Enabled = True
            mnuScramblerExit.Enabled = True
            If lstCategory.ListCount > 1 Then
                mnuScramblerStart.Enabled = True
            Else
                mnuScramblerStart.Enabled = False
            End If
            mnuScramblerStop.Enabled = False
            mnuScoresMain.Enabled = True
            mnuScoresReset.Enabled = True
            mnuScoresPrint.Enabled = True
            mnuPhraseMain.Enabled = False
            mnuRules.Enabled = True
            cboCategory.Enabled = True
        Case Running
            mnuScramblerRefresh.Enabled = False
            mnuScramblerLoad.Enabled = False
            mnuScramblerExit.Enabled = True
            mnuScramblerStart.Enabled = False
            mnuScramblerStop.Enabled = True
            mnuScoresMain.Enabled = False
            mnuPhraseMain.Enabled = True
            mnuRules.Enabled = True
            cboCategory.Enabled = False
    End Select
End Sub

Private Sub Scramble()
    On Error GoTo cancel
    Const MaxTime = 31 'Seconds - to avoid division by zero
    Dim Count1 As Integer
    Dim Count2 As Byte
    Dim Scramble As String
    Dim BeginTime As Single
    Dim Response As String
    Dim Arr() As String
    Dim Temp As Variant
    Dim TempText As String * 11000
    Dim Played() As Boolean
    Dim PlayCount As Integer
    Dim ElapsedTime As Single
    Dim GiveHint As Boolean
    SendChatMessage Header & Black & "AOL " & Green & "<b>" & CurrentAOLVer & "</b> " & Black & _
        "Scrambler Bot by " & Red & "<b>" & CurrentSN & "</b>" & Footer
    mnuRules_Click
    ReDim Played(0 To lstCategory.ListCount - 1) As Boolean
    Do
        Randomize
        Do
            Count1 = Int(Rnd * lstCategory.ListCount)
        Loop While Played(Count1)
        lstCategory.ListIndex = Count1
        Current = lstCategory.List(Count1)
        Scramble = ScramblePhrase(Current)
        SendChatMessage Header & Grey & "<b>#" & Format(PlayCount + 1) & _
            "</b>" & Black & "  Category " & Green & "<b><i>" & cboCategory.Text & _
            "</i></b> " & Black & " Phrase " & Red & "<b>" & _
            Scramble & "</b>" & Footer, False
        GiveHint = True
        BeginTime = Timer
        CurrentUnscrambled = False
        Do
            Response = GetLastLine(ChathWnd)
            ElapsedTime = Timer - BeginTime
            If InStr(1, Trim(LCase$(Response)), Trim(LCase$(Current))) Then
                Arr = Split(Response, ":", 2)
                If Not PeopleToIgnore.Exists(Arr(0)) Then
                    If Not Contestants.Exists(Arr(0)) Then
                        Contestants.Add Arr(0), 1
                    Else
                        Contestants.Item(Arr(0)) = Contestants.Item(Arr(0)) + 1
                    End If
                    SendChatMessage Header & Blue & "<b>" & Arr(0) & "</b> " & _
                        Black & " " & Green & "<b>" & Format(Contestants.Item(Arr(0))) & _
                        "</b>" & IIf(Contestants.Item(Arr(0)) = 1, "pt ", "pts ") & _
                        Black & " " & Red & "<b>" & Current & "</b> " & Black & " <b>" & _
                        Format(ElapsedTime, "0.00") & "s</b>" & Footer, False
                    CurrentUnscrambled = True
                    Exit Do
                End If
            End If
            DoEvents
            If ScramblerStop Then
                Exit Sub
            End If
        Loop Until (ElapsedTime > MaxTime) Or CurrentUnscrambled
        If (Timer - BeginTime > MaxTime) And Not CurrentUnscrambled Then
            SendChatMessage Header & Red & "<b><i>Time Up!" & "</b></i> " & Black & _
                "Correct answer: " & Red & "<b>" & Current & "</b>" & Footer, False
        End If
        lstContestants.Clear
        For Each Temp In Contestants.Keys
            lstContestants.AddItem Temp & ": " & Contestants.Item(Temp)
        Next Temp
        Played(Count1) = True
        lstContestants.Enabled = False
        For Count1 = 0 To lstContestants.ListCount - 1
            If PeopleToIgnore.Exists(Left(lstContestants.List(Count1), InStr(1, lstContestants.List(Count1), ":") - 1)) Then
                lstContestants.Selected(Count1) = True
            End If
        Next Count1
        lstContestants.Enabled = True
        PlayCount = PlayCount + 1
    Loop Until PlayCount = lstCategory.ListCount
    PlayCount = 0
    SendChatMessage Header & Red & "<b>Game Over!</b> " & Footer
    PrintScores
    mnuScoresReset_Click
cancel:
End Sub

Private Sub mnuScramblerStop_Click()
    ScramblerStop = True
    SendChatMessage Header & Red & "<i><b>Game Stopped!</b></i>" & Footer
    EnableControls ReadyRun
End Sub

Private Sub PrintScores()
    Dim Count1 As Integer
    Dim HighestScore As Long
    Dim Name As Byte
    Dim Temp As Long
    For Count1 = 0 To lstContestants.ListCount - 1
        Temp = Val(Mid$(lstContestants.List(Count1), InStr(1, lstContestants.List(Count1), ":") + 1))
        If Temp > HighestScore Then
            HighestScore = Temp
            Name = Count1
        End If
    Next Count1
    SendChatMessage Header & Red & "<b>Scores Listing</b> " & Footer
    For Count1 = 0 To lstContestants.ListCount - 1
        If Count1 = Name Then
            SendChatMessage Header & Green & "<b>" & _
                lstContestants.List(Count1) & "</b>" & Footer
        Else
            SendChatMessage Header & Grey & "<b><i>" & _
                lstContestants.List(Count1) & "</i></b>" & Footer
        End If
    Next Count1
    SendChatMessage Header & Red & "<b>End of Scores</b> " & Footer
End Sub

Private Sub mnuVote_Click()
    Const VoteTimeLimit = 30
    Dim BeginTime As Single
    Dim Count1 As Byte
    Dim VoteIndex As Byte
    If cboCategory.ListCount < 2 Then Exit Sub
    If Not Refresh_(False) Then Exit Sub
    SendChatMessage Header & Black & "AOL " & Green & "<b>" & CurrentAOLVer & "</b>" & Black & " Scrambler bot by " & _
        Red & "<b>" & CurrentSN & "</b> " & Blue & "<b>Vote Bot</b> " & Green & _
        "<b><i>Activated!</i></b>" & Footer
    SendChatMessage Header & Green & "<b>Vote</b>" & Black & _
        " on the following " & Blue & "<b>categories</b>" & Black & " by " & _
        "<b>typing</b> your choice!" & Footer
    SendVoteCategories
    SendChatMessage Header & Black & "You have <b>" & Format(VoteTimeLimit) & _
        "</b> seconds to " & Green & "<b>vote</b> " & Black & "starting " & Green & _
        "<b><i>NOW!</i></b>" & Footer
    BeginTime = Timer
    Do
        DoEvents
    Loop Until Timer - BeginTime > VoteTimeLimit
    SendChatMessage Header & Red & "<b><i>Time Up!</i></b> " & Black & "Votes were:" & Footer
    VoteIndex = AnalyzeVotes(Format(VoteTimeLimit))
    If VoteIndex <> 0 Then
        SendChatMessage Header & Black & "The category shall be: " & Green & "<b><i>" & _
            cboCategory.List(VoteIndex) & "</i></b>" & Footer
        cboCategory.ListIndex = VoteIndex
        mnuScramblerStart_Click
    Else
        SendChatMessage Header & Red & "<b><i>No one wants to play!</i></b>" & Footer
    End If
End Sub

Private Function AnalyzeVotes(VoteTimeLimit As String) As Byte
    Dim ChatText As String * 11000
    Dim TextToAnalyze As String
    Dim Arr() As String
    Dim Votes() As Byte
    Dim Count1 As Byte
    Dim Count2 As Integer
    Dim TopVote As Integer
    Dim VoteIndex As Byte
    Dim Loc As Integer
    Call SendMessageByString(ChathWnd, WM_GETTEXT, Len(ChatText), ChatText)
    Loc = InStrRev(ChatText, " You have " & VoteTimeLimit & " seconds to vote starting NOW! ") + Len(" You have " & VoteTimeLimit & " seconds to vote starting NOW! ") + 1
    If Loc <> 0 Then
        TextToAnalyze = Mid$(ChatText, Loc)
    End If
    Arr = Split(TextToAnalyze, vbCr)
    ReDim Votes(1 To cboCategory.ListCount - 1)
    For Count1 = 1 To cboCategory.ListCount - 1
        For Count2 = 0 To UBound(Arr)
            If InStr(1, LCase$(Arr(Count2)), LCase$(cboCategory.List(Count1))) Then
                Votes(Count1) = Votes(Count1) + 1
            End If
            If Votes(Count1) > TopVote Then
                TopVote = Votes(Count1)
                VoteIndex = Count1
            End If
        Next Count2
    Next Count1
    For Count1 = 1 To cboCategory.ListCount - 1
        If Votes(Count1) > 0 Then
            If Count1 = VoteIndex Then
                SendChatMessage Header & Green & "<b>" & cboCategory.List(Count1) & " : " & _
                    Votes(Count1) & "</b>" & Footer
            Else
                SendChatMessage Header & Grey & "<b><i>" & cboCategory.List(Count1) & " : " & _
                    Votes(Count1) & "</i></b>" & Footer
            End If
        End If
    Next Count1
    AnalyzeVotes = VoteIndex
End Function

Private Sub SendVoteCategories()
    Const MaxLen = 65
    Dim BuildString As String
    Dim SendString As String
    Dim Count1 As Byte
    BuildString = ""
    SendString = RTrim$(Header)
    Do
        Count1 = Count1 + 1
        If Len(cboCategory.List(Count1)) + Len(BuildString) + 3 < MaxLen Then
            BuildString = BuildString & " " & cboCategory.List(Count1) & " "
            SendString = SendString & Grey & " <b>" & _
                cboCategory.List(Count1) & "</b>" & Black & " "
        ElseIf Count1 <> cboCategory.ListCount - 1 Then
            Mid(SendString, Len(SendString) - 4, 2) = "FF"
            SendChatMessage SendString
            SendString = RTrim$(Header)
            BuildString = ""
        End If
    Loop Until Count1 = cboCategory.ListCount - 1
    Mid(SendString, Len(SendString) - 4, 2) = "FF"
    SendChatMessage SendString
End Sub
